/**
 * generated by Xtext 2.15.0
 */
package org.sif.dsl.sat;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;

/**
 * <!-- begin-user-doc -->
 * The <b>Package</b> for the model.
 * It contains accessors for the meta objects to represent
 * <ul>
 *   <li>each class,</li>
 *   <li>each feature of each class,</li>
 *   <li>each enum,</li>
 *   <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * @see org.sif.dsl.sat.SatFactory
 * @model kind="package"
 * @generated
 */
public interface SatPackage extends EPackage
{
  /**
   * The package name.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  String eNAME = "sat";

  /**
   * The package namespace URI.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  String eNS_URI = "http://www.sif.org/dsl/Sat";

  /**
   * The package namespace name.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  String eNS_PREFIX = "sat";

  /**
   * The singleton instance of the package.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  SatPackage eINSTANCE = org.sif.dsl.sat.impl.SatPackageImpl.init();

  /**
   * The meta object id for the '{@link org.sif.dsl.sat.impl.StartImpl <em>Start</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see org.sif.dsl.sat.impl.StartImpl
   * @see org.sif.dsl.sat.impl.SatPackageImpl#getStart()
   * @generated
   */
  int START = 0;

  /**
   * The feature id for the '<em><b>Checks</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int START__CHECKS = 0;

  /**
   * The number of structural features of the '<em>Start</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int START_FEATURE_COUNT = 1;

  /**
   * The meta object id for the '{@link org.sif.dsl.sat.impl.CheckImpl <em>Check</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see org.sif.dsl.sat.impl.CheckImpl
   * @see org.sif.dsl.sat.impl.SatPackageImpl#getCheck()
   * @generated
   */
  int CHECK = 1;

  /**
   * The feature id for the '<em><b>Checks</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int CHECK__CHECKS = START__CHECKS;

  /**
   * The feature id for the '<em><b>Formula</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int CHECK__FORMULA = START_FEATURE_COUNT + 0;

  /**
   * The feature id for the '<em><b>Solver</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int CHECK__SOLVER = START_FEATURE_COUNT + 1;

  /**
   * The number of structural features of the '<em>Check</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int CHECK_FEATURE_COUNT = START_FEATURE_COUNT + 2;

  /**
   * The meta object id for the '{@link org.sif.dsl.sat.impl.SatSolverImpl <em>Solver</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see org.sif.dsl.sat.impl.SatSolverImpl
   * @see org.sif.dsl.sat.impl.SatPackageImpl#getSatSolver()
   * @generated
   */
  int SAT_SOLVER = 2;

  /**
   * The feature id for the '<em><b>Name</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int SAT_SOLVER__NAME = 0;

  /**
   * The number of structural features of the '<em>Solver</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int SAT_SOLVER_FEATURE_COUNT = 1;

  /**
   * The meta object id for the '{@link org.sif.dsl.sat.impl.FormulaImpl <em>Formula</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see org.sif.dsl.sat.impl.FormulaImpl
   * @see org.sif.dsl.sat.impl.SatPackageImpl#getFormula()
   * @generated
   */
  int FORMULA = 3;

  /**
   * The feature id for the '<em><b>Id</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int FORMULA__ID = 0;

  /**
   * The number of structural features of the '<em>Formula</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int FORMULA_FEATURE_COUNT = 1;

  /**
   * The meta object id for the '{@link org.sif.dsl.sat.impl.BiimpliesImpl <em>Biimplies</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see org.sif.dsl.sat.impl.BiimpliesImpl
   * @see org.sif.dsl.sat.impl.SatPackageImpl#getBiimplies()
   * @generated
   */
  int BIIMPLIES = 4;

  /**
   * The feature id for the '<em><b>Id</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int BIIMPLIES__ID = FORMULA__ID;

  /**
   * The feature id for the '<em><b>Left</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int BIIMPLIES__LEFT = FORMULA_FEATURE_COUNT + 0;

  /**
   * The feature id for the '<em><b>Right</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int BIIMPLIES__RIGHT = FORMULA_FEATURE_COUNT + 1;

  /**
   * The number of structural features of the '<em>Biimplies</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int BIIMPLIES_FEATURE_COUNT = FORMULA_FEATURE_COUNT + 2;

  /**
   * The meta object id for the '{@link org.sif.dsl.sat.impl.ImpliesImpl <em>Implies</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see org.sif.dsl.sat.impl.ImpliesImpl
   * @see org.sif.dsl.sat.impl.SatPackageImpl#getImplies()
   * @generated
   */
  int IMPLIES = 5;

  /**
   * The feature id for the '<em><b>Id</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int IMPLIES__ID = FORMULA__ID;

  /**
   * The feature id for the '<em><b>Left</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int IMPLIES__LEFT = FORMULA_FEATURE_COUNT + 0;

  /**
   * The feature id for the '<em><b>Right</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int IMPLIES__RIGHT = FORMULA_FEATURE_COUNT + 1;

  /**
   * The number of structural features of the '<em>Implies</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int IMPLIES_FEATURE_COUNT = FORMULA_FEATURE_COUNT + 2;

  /**
   * The meta object id for the '{@link org.sif.dsl.sat.impl.OrImpl <em>Or</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see org.sif.dsl.sat.impl.OrImpl
   * @see org.sif.dsl.sat.impl.SatPackageImpl#getOr()
   * @generated
   */
  int OR = 6;

  /**
   * The feature id for the '<em><b>Id</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int OR__ID = FORMULA__ID;

  /**
   * The feature id for the '<em><b>Left</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int OR__LEFT = FORMULA_FEATURE_COUNT + 0;

  /**
   * The feature id for the '<em><b>Right</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int OR__RIGHT = FORMULA_FEATURE_COUNT + 1;

  /**
   * The number of structural features of the '<em>Or</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int OR_FEATURE_COUNT = FORMULA_FEATURE_COUNT + 2;

  /**
   * The meta object id for the '{@link org.sif.dsl.sat.impl.ExcludesImpl <em>Excludes</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see org.sif.dsl.sat.impl.ExcludesImpl
   * @see org.sif.dsl.sat.impl.SatPackageImpl#getExcludes()
   * @generated
   */
  int EXCLUDES = 7;

  /**
   * The feature id for the '<em><b>Id</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int EXCLUDES__ID = FORMULA__ID;

  /**
   * The feature id for the '<em><b>Left</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int EXCLUDES__LEFT = FORMULA_FEATURE_COUNT + 0;

  /**
   * The feature id for the '<em><b>Right</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int EXCLUDES__RIGHT = FORMULA_FEATURE_COUNT + 1;

  /**
   * The number of structural features of the '<em>Excludes</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int EXCLUDES_FEATURE_COUNT = FORMULA_FEATURE_COUNT + 2;

  /**
   * The meta object id for the '{@link org.sif.dsl.sat.impl.AndImpl <em>And</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see org.sif.dsl.sat.impl.AndImpl
   * @see org.sif.dsl.sat.impl.SatPackageImpl#getAnd()
   * @generated
   */
  int AND = 8;

  /**
   * The feature id for the '<em><b>Id</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int AND__ID = FORMULA__ID;

  /**
   * The feature id for the '<em><b>Left</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int AND__LEFT = FORMULA_FEATURE_COUNT + 0;

  /**
   * The feature id for the '<em><b>Right</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int AND__RIGHT = FORMULA_FEATURE_COUNT + 1;

  /**
   * The number of structural features of the '<em>And</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int AND_FEATURE_COUNT = FORMULA_FEATURE_COUNT + 2;

  /**
   * The meta object id for the '{@link org.sif.dsl.sat.impl.NotImpl <em>Not</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see org.sif.dsl.sat.impl.NotImpl
   * @see org.sif.dsl.sat.impl.SatPackageImpl#getNot()
   * @generated
   */
  int NOT = 9;

  /**
   * The feature id for the '<em><b>Id</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int NOT__ID = FORMULA__ID;

  /**
   * The feature id for the '<em><b>Right</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int NOT__RIGHT = FORMULA_FEATURE_COUNT + 0;

  /**
   * The number of structural features of the '<em>Not</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int NOT_FEATURE_COUNT = FORMULA_FEATURE_COUNT + 1;

  /**
   * The meta object id for the '{@link org.sif.dsl.sat.impl.PFormulaImpl <em>PFormula</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see org.sif.dsl.sat.impl.PFormulaImpl
   * @see org.sif.dsl.sat.impl.SatPackageImpl#getPFormula()
   * @generated
   */
  int PFORMULA = 10;

  /**
   * The feature id for the '<em><b>Id</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int PFORMULA__ID = FORMULA__ID;

  /**
   * The feature id for the '<em><b>Expr</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int PFORMULA__EXPR = FORMULA_FEATURE_COUNT + 0;

  /**
   * The number of structural features of the '<em>PFormula</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int PFORMULA_FEATURE_COUNT = FORMULA_FEATURE_COUNT + 1;


  /**
   * Returns the meta object for class '{@link org.sif.dsl.sat.Start <em>Start</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Start</em>'.
   * @see org.sif.dsl.sat.Start
   * @generated
   */
  EClass getStart();

  /**
   * Returns the meta object for the containment reference list '{@link org.sif.dsl.sat.Start#getChecks <em>Checks</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference list '<em>Checks</em>'.
   * @see org.sif.dsl.sat.Start#getChecks()
   * @see #getStart()
   * @generated
   */
  EReference getStart_Checks();

  /**
   * Returns the meta object for class '{@link org.sif.dsl.sat.Check <em>Check</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Check</em>'.
   * @see org.sif.dsl.sat.Check
   * @generated
   */
  EClass getCheck();

  /**
   * Returns the meta object for the containment reference '{@link org.sif.dsl.sat.Check#getFormula <em>Formula</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference '<em>Formula</em>'.
   * @see org.sif.dsl.sat.Check#getFormula()
   * @see #getCheck()
   * @generated
   */
  EReference getCheck_Formula();

  /**
   * Returns the meta object for the containment reference '{@link org.sif.dsl.sat.Check#getSolver <em>Solver</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference '<em>Solver</em>'.
   * @see org.sif.dsl.sat.Check#getSolver()
   * @see #getCheck()
   * @generated
   */
  EReference getCheck_Solver();

  /**
   * Returns the meta object for class '{@link org.sif.dsl.sat.SatSolver <em>Solver</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Solver</em>'.
   * @see org.sif.dsl.sat.SatSolver
   * @generated
   */
  EClass getSatSolver();

  /**
   * Returns the meta object for the attribute '{@link org.sif.dsl.sat.SatSolver#getName <em>Name</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Name</em>'.
   * @see org.sif.dsl.sat.SatSolver#getName()
   * @see #getSatSolver()
   * @generated
   */
  EAttribute getSatSolver_Name();

  /**
   * Returns the meta object for class '{@link org.sif.dsl.sat.Formula <em>Formula</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Formula</em>'.
   * @see org.sif.dsl.sat.Formula
   * @generated
   */
  EClass getFormula();

  /**
   * Returns the meta object for the attribute '{@link org.sif.dsl.sat.Formula#getId <em>Id</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Id</em>'.
   * @see org.sif.dsl.sat.Formula#getId()
   * @see #getFormula()
   * @generated
   */
  EAttribute getFormula_Id();

  /**
   * Returns the meta object for class '{@link org.sif.dsl.sat.Biimplies <em>Biimplies</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Biimplies</em>'.
   * @see org.sif.dsl.sat.Biimplies
   * @generated
   */
  EClass getBiimplies();

  /**
   * Returns the meta object for the containment reference '{@link org.sif.dsl.sat.Biimplies#getLeft <em>Left</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference '<em>Left</em>'.
   * @see org.sif.dsl.sat.Biimplies#getLeft()
   * @see #getBiimplies()
   * @generated
   */
  EReference getBiimplies_Left();

  /**
   * Returns the meta object for the containment reference '{@link org.sif.dsl.sat.Biimplies#getRight <em>Right</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference '<em>Right</em>'.
   * @see org.sif.dsl.sat.Biimplies#getRight()
   * @see #getBiimplies()
   * @generated
   */
  EReference getBiimplies_Right();

  /**
   * Returns the meta object for class '{@link org.sif.dsl.sat.Implies <em>Implies</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Implies</em>'.
   * @see org.sif.dsl.sat.Implies
   * @generated
   */
  EClass getImplies();

  /**
   * Returns the meta object for the containment reference '{@link org.sif.dsl.sat.Implies#getLeft <em>Left</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference '<em>Left</em>'.
   * @see org.sif.dsl.sat.Implies#getLeft()
   * @see #getImplies()
   * @generated
   */
  EReference getImplies_Left();

  /**
   * Returns the meta object for the containment reference '{@link org.sif.dsl.sat.Implies#getRight <em>Right</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference '<em>Right</em>'.
   * @see org.sif.dsl.sat.Implies#getRight()
   * @see #getImplies()
   * @generated
   */
  EReference getImplies_Right();

  /**
   * Returns the meta object for class '{@link org.sif.dsl.sat.Or <em>Or</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Or</em>'.
   * @see org.sif.dsl.sat.Or
   * @generated
   */
  EClass getOr();

  /**
   * Returns the meta object for the containment reference '{@link org.sif.dsl.sat.Or#getLeft <em>Left</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference '<em>Left</em>'.
   * @see org.sif.dsl.sat.Or#getLeft()
   * @see #getOr()
   * @generated
   */
  EReference getOr_Left();

  /**
   * Returns the meta object for the containment reference '{@link org.sif.dsl.sat.Or#getRight <em>Right</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference '<em>Right</em>'.
   * @see org.sif.dsl.sat.Or#getRight()
   * @see #getOr()
   * @generated
   */
  EReference getOr_Right();

  /**
   * Returns the meta object for class '{@link org.sif.dsl.sat.Excludes <em>Excludes</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Excludes</em>'.
   * @see org.sif.dsl.sat.Excludes
   * @generated
   */
  EClass getExcludes();

  /**
   * Returns the meta object for the containment reference '{@link org.sif.dsl.sat.Excludes#getLeft <em>Left</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference '<em>Left</em>'.
   * @see org.sif.dsl.sat.Excludes#getLeft()
   * @see #getExcludes()
   * @generated
   */
  EReference getExcludes_Left();

  /**
   * Returns the meta object for the containment reference '{@link org.sif.dsl.sat.Excludes#getRight <em>Right</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference '<em>Right</em>'.
   * @see org.sif.dsl.sat.Excludes#getRight()
   * @see #getExcludes()
   * @generated
   */
  EReference getExcludes_Right();

  /**
   * Returns the meta object for class '{@link org.sif.dsl.sat.And <em>And</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>And</em>'.
   * @see org.sif.dsl.sat.And
   * @generated
   */
  EClass getAnd();

  /**
   * Returns the meta object for the containment reference '{@link org.sif.dsl.sat.And#getLeft <em>Left</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference '<em>Left</em>'.
   * @see org.sif.dsl.sat.And#getLeft()
   * @see #getAnd()
   * @generated
   */
  EReference getAnd_Left();

  /**
   * Returns the meta object for the containment reference '{@link org.sif.dsl.sat.And#getRight <em>Right</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference '<em>Right</em>'.
   * @see org.sif.dsl.sat.And#getRight()
   * @see #getAnd()
   * @generated
   */
  EReference getAnd_Right();

  /**
   * Returns the meta object for class '{@link org.sif.dsl.sat.Not <em>Not</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Not</em>'.
   * @see org.sif.dsl.sat.Not
   * @generated
   */
  EClass getNot();

  /**
   * Returns the meta object for the containment reference '{@link org.sif.dsl.sat.Not#getRight <em>Right</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference '<em>Right</em>'.
   * @see org.sif.dsl.sat.Not#getRight()
   * @see #getNot()
   * @generated
   */
  EReference getNot_Right();

  /**
   * Returns the meta object for class '{@link org.sif.dsl.sat.PFormula <em>PFormula</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>PFormula</em>'.
   * @see org.sif.dsl.sat.PFormula
   * @generated
   */
  EClass getPFormula();

  /**
   * Returns the meta object for the containment reference '{@link org.sif.dsl.sat.PFormula#getExpr <em>Expr</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference '<em>Expr</em>'.
   * @see org.sif.dsl.sat.PFormula#getExpr()
   * @see #getPFormula()
   * @generated
   */
  EReference getPFormula_Expr();

  /**
   * Returns the factory that creates the instances of the model.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the factory that creates the instances of the model.
   * @generated
   */
  SatFactory getSatFactory();

  /**
   * <!-- begin-user-doc -->
   * Defines literals for the meta objects that represent
   * <ul>
   *   <li>each class,</li>
   *   <li>each feature of each class,</li>
   *   <li>each enum,</li>
   *   <li>and each data type</li>
   * </ul>
   * <!-- end-user-doc -->
   * @generated
   */
  interface Literals
  {
    /**
     * The meta object literal for the '{@link org.sif.dsl.sat.impl.StartImpl <em>Start</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see org.sif.dsl.sat.impl.StartImpl
     * @see org.sif.dsl.sat.impl.SatPackageImpl#getStart()
     * @generated
     */
    EClass START = eINSTANCE.getStart();

    /**
     * The meta object literal for the '<em><b>Checks</b></em>' containment reference list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference START__CHECKS = eINSTANCE.getStart_Checks();

    /**
     * The meta object literal for the '{@link org.sif.dsl.sat.impl.CheckImpl <em>Check</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see org.sif.dsl.sat.impl.CheckImpl
     * @see org.sif.dsl.sat.impl.SatPackageImpl#getCheck()
     * @generated
     */
    EClass CHECK = eINSTANCE.getCheck();

    /**
     * The meta object literal for the '<em><b>Formula</b></em>' containment reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference CHECK__FORMULA = eINSTANCE.getCheck_Formula();

    /**
     * The meta object literal for the '<em><b>Solver</b></em>' containment reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference CHECK__SOLVER = eINSTANCE.getCheck_Solver();

    /**
     * The meta object literal for the '{@link org.sif.dsl.sat.impl.SatSolverImpl <em>Solver</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see org.sif.dsl.sat.impl.SatSolverImpl
     * @see org.sif.dsl.sat.impl.SatPackageImpl#getSatSolver()
     * @generated
     */
    EClass SAT_SOLVER = eINSTANCE.getSatSolver();

    /**
     * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute SAT_SOLVER__NAME = eINSTANCE.getSatSolver_Name();

    /**
     * The meta object literal for the '{@link org.sif.dsl.sat.impl.FormulaImpl <em>Formula</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see org.sif.dsl.sat.impl.FormulaImpl
     * @see org.sif.dsl.sat.impl.SatPackageImpl#getFormula()
     * @generated
     */
    EClass FORMULA = eINSTANCE.getFormula();

    /**
     * The meta object literal for the '<em><b>Id</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute FORMULA__ID = eINSTANCE.getFormula_Id();

    /**
     * The meta object literal for the '{@link org.sif.dsl.sat.impl.BiimpliesImpl <em>Biimplies</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see org.sif.dsl.sat.impl.BiimpliesImpl
     * @see org.sif.dsl.sat.impl.SatPackageImpl#getBiimplies()
     * @generated
     */
    EClass BIIMPLIES = eINSTANCE.getBiimplies();

    /**
     * The meta object literal for the '<em><b>Left</b></em>' containment reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference BIIMPLIES__LEFT = eINSTANCE.getBiimplies_Left();

    /**
     * The meta object literal for the '<em><b>Right</b></em>' containment reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference BIIMPLIES__RIGHT = eINSTANCE.getBiimplies_Right();

    /**
     * The meta object literal for the '{@link org.sif.dsl.sat.impl.ImpliesImpl <em>Implies</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see org.sif.dsl.sat.impl.ImpliesImpl
     * @see org.sif.dsl.sat.impl.SatPackageImpl#getImplies()
     * @generated
     */
    EClass IMPLIES = eINSTANCE.getImplies();

    /**
     * The meta object literal for the '<em><b>Left</b></em>' containment reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference IMPLIES__LEFT = eINSTANCE.getImplies_Left();

    /**
     * The meta object literal for the '<em><b>Right</b></em>' containment reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference IMPLIES__RIGHT = eINSTANCE.getImplies_Right();

    /**
     * The meta object literal for the '{@link org.sif.dsl.sat.impl.OrImpl <em>Or</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see org.sif.dsl.sat.impl.OrImpl
     * @see org.sif.dsl.sat.impl.SatPackageImpl#getOr()
     * @generated
     */
    EClass OR = eINSTANCE.getOr();

    /**
     * The meta object literal for the '<em><b>Left</b></em>' containment reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference OR__LEFT = eINSTANCE.getOr_Left();

    /**
     * The meta object literal for the '<em><b>Right</b></em>' containment reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference OR__RIGHT = eINSTANCE.getOr_Right();

    /**
     * The meta object literal for the '{@link org.sif.dsl.sat.impl.ExcludesImpl <em>Excludes</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see org.sif.dsl.sat.impl.ExcludesImpl
     * @see org.sif.dsl.sat.impl.SatPackageImpl#getExcludes()
     * @generated
     */
    EClass EXCLUDES = eINSTANCE.getExcludes();

    /**
     * The meta object literal for the '<em><b>Left</b></em>' containment reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference EXCLUDES__LEFT = eINSTANCE.getExcludes_Left();

    /**
     * The meta object literal for the '<em><b>Right</b></em>' containment reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference EXCLUDES__RIGHT = eINSTANCE.getExcludes_Right();

    /**
     * The meta object literal for the '{@link org.sif.dsl.sat.impl.AndImpl <em>And</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see org.sif.dsl.sat.impl.AndImpl
     * @see org.sif.dsl.sat.impl.SatPackageImpl#getAnd()
     * @generated
     */
    EClass AND = eINSTANCE.getAnd();

    /**
     * The meta object literal for the '<em><b>Left</b></em>' containment reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference AND__LEFT = eINSTANCE.getAnd_Left();

    /**
     * The meta object literal for the '<em><b>Right</b></em>' containment reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference AND__RIGHT = eINSTANCE.getAnd_Right();

    /**
     * The meta object literal for the '{@link org.sif.dsl.sat.impl.NotImpl <em>Not</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see org.sif.dsl.sat.impl.NotImpl
     * @see org.sif.dsl.sat.impl.SatPackageImpl#getNot()
     * @generated
     */
    EClass NOT = eINSTANCE.getNot();

    /**
     * The meta object literal for the '<em><b>Right</b></em>' containment reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference NOT__RIGHT = eINSTANCE.getNot_Right();

    /**
     * The meta object literal for the '{@link org.sif.dsl.sat.impl.PFormulaImpl <em>PFormula</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see org.sif.dsl.sat.impl.PFormulaImpl
     * @see org.sif.dsl.sat.impl.SatPackageImpl#getPFormula()
     * @generated
     */
    EClass PFORMULA = eINSTANCE.getPFormula();

    /**
     * The meta object literal for the '<em><b>Expr</b></em>' containment reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference PFORMULA__EXPR = eINSTANCE.getPFormula_Expr();

  }

} //SatPackage
